]> git.street.me.uk Git - andy/dehydrated.git/blob - dehydrated
9e8a98d051256fdcb53ee9a3fcabf5a45fdb11ad
[andy/dehydrated.git] / dehydrated
1 #!/usr/bin/env bash
2
3 # dehydrated by lukas2511
4 # Source: https://github.com/lukas2511/dehydrated
5 #
6 # This script is licensed under The MIT License (see LICENSE for more information).
7
8 set -e
9 set -u
10 set -o pipefail
11 [[ -n "${ZSH_VERSION:-}" ]] && set -o SH_WORD_SPLIT && set +o FUNCTION_ARGZERO
12 umask 077 # paranoid umask, we're creating private keys
13
14 # Find directory in which this script is stored by traversing all symbolic links
15 SOURCE="${0}"
16 while [ -h "$SOURCE" ]; do # resolve $SOURCE until the file is no longer a symlink
17   DIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )"
18   SOURCE="$(readlink "$SOURCE")"
19   [[ $SOURCE != /* ]] && SOURCE="$DIR/$SOURCE" # if $SOURCE was a relative symlink, we need to resolve it relative to the path where the symlink file was located
20 done
21 SCRIPTDIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )"
22
23 BASEDIR="${SCRIPTDIR}"
24
25 # Create (identifiable) temporary files
26 _mktemp() {
27   # shellcheck disable=SC2068
28   mktemp ${@:-} "${TMPDIR:-/tmp}/dehydrated-XXXXXX"
29 }
30
31 # Check for script dependencies
32 check_dependencies() {
33   # just execute some dummy and/or version commands to see if required tools exist and are actually usable
34   openssl version > /dev/null 2>&1 || _exiterr "This script requires an openssl binary."
35   _sed "" < /dev/null > /dev/null 2>&1 || _exiterr "This script requires sed with support for extended (modern) regular expressions."
36   command -v grep > /dev/null 2>&1 || _exiterr "This script requires grep."
37   command -v mktemp > /dev/null 2>&1 || _exiterr "This script requires mktemp."
38   command -v diff > /dev/null 2>&1 || _exiterr "This script requires diff."
39
40   # curl returns with an error code in some ancient versions so we have to catch that
41   set +e
42   curl -V > /dev/null 2>&1
43   retcode="$?"
44   set -e
45   if [[ ! "${retcode}" = "0" ]] && [[ ! "${retcode}" = "2" ]]; then
46     _exiterr "This script requires curl."
47   fi
48 }
49
50 store_configvars() {
51   __KEY_ALGO="${KEY_ALGO}"
52   __OCSP_MUST_STAPLE="${OCSP_MUST_STAPLE}"
53   __PRIVATE_KEY_RENEW="${PRIVATE_KEY_RENEW}"
54   __KEYSIZE="${KEYSIZE}"
55   __CHALLENGETYPE="${CHALLENGETYPE}"
56   __HOOK="${HOOK}"
57   __WELLKNOWN="${WELLKNOWN}"
58   __HOOK_CHAIN="${HOOK_CHAIN}"
59   __OPENSSL_CNF="${OPENSSL_CNF}"
60   __RENEW_DAYS="${RENEW_DAYS}"
61   __IP_VERSION="${IP_VERSION}"
62 }
63
64 reset_configvars() {
65   KEY_ALGO="${__KEY_ALGO}"
66   OCSP_MUST_STAPLE="${__OCSP_MUST_STAPLE}"
67   PRIVATE_KEY_RENEW="${__PRIVATE_KEY_RENEW}"
68   KEYSIZE="${__KEYSIZE}"
69   CHALLENGETYPE="${__CHALLENGETYPE}"
70   HOOK="${__HOOK}"
71   WELLKNOWN="${__WELLKNOWN}"
72   HOOK_CHAIN="${__HOOK_CHAIN}"
73   OPENSSL_CNF="${__OPENSSL_CNF}"
74   RENEW_DAYS="${__RENEW_DAYS}"
75   IP_VERSION="${__IP_VERSION}"
76 }
77
78 # verify configuration values
79 verify_config() {
80   [[ "${CHALLENGETYPE}" =~ (http-01|dns-01) ]] || _exiterr "Unknown challenge type ${CHALLENGETYPE}... can not continue."
81   if [[ "${CHALLENGETYPE}" = "dns-01" ]] && [[ -z "${HOOK}" ]]; then
82     _exiterr "Challenge type dns-01 needs a hook script for deployment... can not continue."
83   fi
84   if [[ "${CHALLENGETYPE}" = "http-01" && ! -d "${WELLKNOWN}" ]]; then
85     _exiterr "WELLKNOWN directory doesn't exist, please create ${WELLKNOWN} and set appropriate permissions."
86   fi
87   [[ "${KEY_ALGO}" =~ ^(rsa|prime256v1|secp384r1)$ ]] || _exiterr "Unknown public key algorithm ${KEY_ALGO}... can not continue."
88   if [[ -n "${IP_VERSION}" ]]; then
89     [[ "${IP_VERSION}" = "4" || "${IP_VERSION}" = "6" ]] || _exiterr "Unknown IP version ${IP_VERSION}... can not continue."
90   fi
91 }
92
93 # Setup default config values, search for and load configuration files
94 load_config() {
95   # Check for config in various locations
96   if [[ -z "${CONFIG:-}" ]]; then
97     for check_config in "/etc/dehydrated" "/usr/local/etc/dehydrated" "${PWD}" "${SCRIPTDIR}"; do
98       if [[ -f "${check_config}/config" ]]; then
99         BASEDIR="${check_config}"
100         CONFIG="${check_config}/config"
101         break
102       fi
103     done
104   fi
105
106   # Default values
107   CA="https://acme-v01.api.letsencrypt.org/directory"
108   LICENSE="https://letsencrypt.org/documents/LE-SA-v1.1.1-August-1-2016.pdf"
109   CERTDIR=
110   ACCOUNTDIR=
111   CHALLENGETYPE="http-01"
112   CONFIG_D=
113   DOMAINS_D=
114   DOMAINS_TXT=
115   HOOK=
116   HOOK_CHAIN="no"
117   RENEW_DAYS="30"
118   KEYSIZE="4096"
119   WELLKNOWN=
120   PRIVATE_KEY_RENEW="yes"
121   PRIVATE_KEY_ROLLOVER="no"
122   KEY_ALGO=rsa
123   OPENSSL_CNF="$(openssl version -d | cut -d\" -f2)/openssl.cnf"
124   CONTACT_EMAIL=
125   LOCKFILE=
126   OCSP_MUST_STAPLE="no"
127   IP_VERSION=
128
129   if [[ -z "${CONFIG:-}" ]]; then
130     echo "#" >&2
131     echo "# !! WARNING !! No main config file found, using default config!" >&2
132     echo "#" >&2
133   elif [[ -f "${CONFIG}" ]]; then
134     echo "# INFO: Using main config file ${CONFIG}"
135     BASEDIR="$(dirname "${CONFIG}")"
136     # shellcheck disable=SC1090
137     . "${CONFIG}"
138   else
139     _exiterr "Specified config file doesn't exist."
140   fi
141
142   if [[ -n "${CONFIG_D}" ]]; then
143     if [[ ! -d "${CONFIG_D}" ]]; then
144       _exiterr "The path ${CONFIG_D} specified for CONFIG_D does not point to a directory." >&2
145     fi
146
147     for check_config_d in "${CONFIG_D}"/*.sh; do
148       if [[ ! -e "${check_config_d}" ]]; then
149         echo "# !! WARNING !! Extra configuration directory ${CONFIG_D} exists, but no configuration found in it." >&2
150         break
151       elif [[ -f "${check_config_d}" ]] && [[ -r "${check_config_d}" ]]; then
152         echo "# INFO: Using additional config file ${check_config_d}"
153         # shellcheck disable=SC1090
154         . "${check_config_d}"
155       else
156         _exiterr "Specified additional config ${check_config_d} is not readable or not a file at all." >&2
157       fi
158    done
159   fi
160
161   # Remove slash from end of BASEDIR. Mostly for cleaner outputs, doesn't change functionality.
162   BASEDIR="${BASEDIR%%/}"
163
164   # Check BASEDIR and set default variables
165   [[ -d "${BASEDIR}" ]] || _exiterr "BASEDIR does not exist: ${BASEDIR}"
166
167   CAHASH="$(echo "${CA}" | urlbase64)"
168   [[ -z "${ACCOUNTDIR}" ]] && ACCOUNTDIR="${BASEDIR}/accounts"
169   mkdir -p "${ACCOUNTDIR}/${CAHASH}"
170   [[ -f "${ACCOUNTDIR}/${CAHASH}/config" ]] && . "${ACCOUNTDIR}/${CAHASH}/config"
171   ACCOUNT_KEY="${ACCOUNTDIR}/${CAHASH}/account_key.pem"
172   ACCOUNT_KEY_JSON="${ACCOUNTDIR}/${CAHASH}/registration_info.json"
173
174   if [[ -f "${BASEDIR}/private_key.pem" ]] && [[ ! -f "${ACCOUNT_KEY}" ]]; then
175     echo "! Moving private_key.pem to ${ACCOUNT_KEY}"
176     mv "${BASEDIR}/private_key.pem" "${ACCOUNT_KEY}"
177   fi
178   if [[ -f "${BASEDIR}/private_key.json" ]] && [[ ! -f "${ACCOUNT_KEY_JSON}" ]]; then
179     echo "! Moving private_key.json to ${ACCOUNT_KEY_JSON}"
180     mv "${BASEDIR}/private_key.json" "${ACCOUNT_KEY_JSON}"
181   fi
182
183   [[ -z "${CERTDIR}" ]] && CERTDIR="${BASEDIR}/certs"
184   [[ -z "${DOMAINS_TXT}" ]] && DOMAINS_TXT="${BASEDIR}/domains.txt"
185   [[ -z "${WELLKNOWN}" ]] && WELLKNOWN="/var/www/dehydrated"
186   [[ -z "${LOCKFILE}" ]] && LOCKFILE="${BASEDIR}/lock"
187   [[ -n "${PARAM_LOCKFILE_SUFFIX:-}" ]] && LOCKFILE="${LOCKFILE}-${PARAM_LOCKFILE_SUFFIX}"
188   [[ -n "${PARAM_NO_LOCK:-}" ]] && LOCKFILE=""
189
190   [[ -n "${PARAM_HOOK:-}" ]] && HOOK="${PARAM_HOOK}"
191   [[ -n "${PARAM_CERTDIR:-}" ]] && CERTDIR="${PARAM_CERTDIR}"
192   [[ -n "${PARAM_CHALLENGETYPE:-}" ]] && CHALLENGETYPE="${PARAM_CHALLENGETYPE}"
193   [[ -n "${PARAM_KEY_ALGO:-}" ]] && KEY_ALGO="${PARAM_KEY_ALGO}"
194   [[ -n "${PARAM_OCSP_MUST_STAPLE:-}" ]] && OCSP_MUST_STAPLE="${PARAM_OCSP_MUST_STAPLE}"
195   [[ -n "${PARAM_IP_VERSION:-}" ]] && IP_VERSION="${PARAM_IP_VERSION}"
196
197   verify_config
198   store_configvars
199 }
200
201 # Initialize system
202 init_system() {
203   load_config
204
205   # Lockfile handling (prevents concurrent access)
206   if [[ -n "${LOCKFILE}" ]]; then
207     LOCKDIR="$(dirname "${LOCKFILE}")"
208     [[ -w "${LOCKDIR}" ]] || _exiterr "Directory ${LOCKDIR} for LOCKFILE ${LOCKFILE} is not writable, aborting."
209     ( set -C; date > "${LOCKFILE}" ) 2>/dev/null || _exiterr "Lock file '${LOCKFILE}' present, aborting."
210     remove_lock() { rm -f "${LOCKFILE}"; }
211     trap 'remove_lock' EXIT
212   fi
213
214   # Get CA URLs
215   CA_DIRECTORY="$(http_request get "${CA}")"
216   CA_NEW_CERT="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value new-cert)" &&
217   CA_NEW_AUTHZ="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value new-authz)" &&
218   CA_NEW_REG="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value new-reg)" &&
219   # shellcheck disable=SC2015
220   CA_REVOKE_CERT="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value revoke-cert)" ||
221   _exiterr "Problem retrieving ACME/CA-URLs, check if your configured CA points to the directory entrypoint."
222
223   # Export some environment variables to be used in hook script
224   export WELLKNOWN BASEDIR CERTDIR CONFIG COMMAND
225
226   # Checking for private key ...
227   register_new_key="no"
228   if [[ -n "${PARAM_ACCOUNT_KEY:-}" ]]; then
229     # a private key was specified from the command line so use it for this run
230     echo "Using private key ${PARAM_ACCOUNT_KEY} instead of account key"
231     ACCOUNT_KEY="${PARAM_ACCOUNT_KEY}"
232     ACCOUNT_KEY_JSON="${PARAM_ACCOUNT_KEY}.json"
233   else
234     # Check if private account key exists, if it doesn't exist yet generate a new one (rsa key)
235     if [[ ! -e "${ACCOUNT_KEY}" ]]; then
236       echo "+ Generating account key..."
237       _openssl genrsa -out "${ACCOUNT_KEY}" "${KEYSIZE}"
238       register_new_key="yes"
239     fi
240   fi
241   openssl rsa -in "${ACCOUNT_KEY}" -check 2>/dev/null > /dev/null || _exiterr "Account key is not valid, can not continue."
242
243   # Get public components from private key and calculate thumbprint
244   pubExponent64="$(printf '%x' "$(openssl rsa -in "${ACCOUNT_KEY}" -noout -text | awk '/publicExponent/ {print $2}')" | hex2bin | urlbase64)"
245   pubMod64="$(openssl rsa -in "${ACCOUNT_KEY}" -noout -modulus | cut -d'=' -f2 | hex2bin | urlbase64)"
246
247   thumbprint="$(printf '{"e":"%s","kty":"RSA","n":"%s"}' "${pubExponent64}" "${pubMod64}" | openssl dgst -sha256 -binary | urlbase64)"
248
249   # If we generated a new private key in the step above we have to register it with the acme-server
250   if [[ "${register_new_key}" = "yes" ]]; then
251     echo "+ Registering account key with ACME server..."
252     [[ ! -z "${CA_NEW_REG}" ]] || _exiterr "Certificate authority doesn't allow registrations."
253     # If an email for the contact has been provided then adding it to the registration request
254     FAILED=false
255     if [[ -n "${CONTACT_EMAIL}" ]]; then
256       (signed_request "${CA_NEW_REG}" '{"resource": "new-reg", "contact":["mailto:'"${CONTACT_EMAIL}"'"], "agreement": "'"$LICENSE"'"}' > "${ACCOUNT_KEY_JSON}") || FAILED=true
257     else
258       (signed_request "${CA_NEW_REG}" '{"resource": "new-reg", "agreement": "'"$LICENSE"'"}' > "${ACCOUNT_KEY_JSON}") || FAILED=true
259     fi
260     if [[ "${FAILED}" = "true" ]]; then
261       echo
262       echo
263       echo "Error registering account key. See message above for more information."
264       rm "${ACCOUNT_KEY}" "${ACCOUNT_KEY_JSON}"
265       exit 1
266     fi
267   fi
268
269 }
270
271 # Different sed version for different os types...
272 _sed() {
273   if [[ "${OSTYPE}" = "Linux" ]]; then
274     sed -r "${@}"
275   else
276     sed -E "${@}"
277   fi
278 }
279
280 # Print error message and exit with error
281 _exiterr() {
282   echo "ERROR: ${1}" >&2
283   exit 1
284 }
285
286 # Remove newlines and whitespace from json
287 clean_json() {
288   tr -d '\r\n' | _sed -e 's/ +/ /g' -e 's/\{ /{/g' -e 's/ \}/}/g' -e 's/\[ /[/g' -e 's/ \]/]/g'
289 }
290
291 # Encode data as url-safe formatted base64
292 urlbase64() {
293   # urlbase64: base64 encoded string with '+' replaced with '-' and '/' replaced with '_'
294   openssl base64 -e | tr -d '\n\r' | _sed -e 's:=*$::g' -e 'y:+/:-_:'
295 }
296
297 # Convert hex string to binary data
298 hex2bin() {
299   # Remove spaces, add leading zero, escape as hex string and parse with printf
300   printf -- "$(cat | _sed -e 's/[[:space:]]//g' -e 's/^(.(.{2})*)$/0\1/' -e 's/(.{2})/\\x\1/g')"
301 }
302
303 # Get string value from json dictionary
304 get_json_string_value() {
305   local filter
306   filter=$(printf 's/.*"%s": *"\([^"]*\)".*/\\1/p' "$1")
307   sed -n "${filter}"
308 }
309
310 rm_json_arrays() {
311   local filter
312   filter='s/\[[^][]*\]/null/g'
313   # remove three levels of nested arrays
314   sed -e "${filter}" -e "${filter}" -e "${filter}"
315 }
316
317 # OpenSSL writes to stderr/stdout even when there are no errors. So just
318 # display the output if the exit code was != 0 to simplify debugging.
319 _openssl() {
320   set +e
321   out="$(openssl "${@}" 2>&1)"
322   res=$?
323   set -e
324   if [[ ${res} -ne 0 ]]; then
325     echo "  + ERROR: failed to run $* (Exitcode: ${res})" >&2
326     echo >&2
327     echo "Details:" >&2
328     echo "${out}" >&2
329     echo >&2
330     exit ${res}
331   fi
332 }
333
334 # Send http(s) request with specified method
335 http_request() {
336   tempcont="$(_mktemp)"
337
338   if [[ -n "${IP_VERSION:-}" ]]; then
339       ip_version="-${IP_VERSION}"
340   fi
341
342   set +e
343   if [[ "${1}" = "head" ]]; then
344     statuscode="$(curl ${ip_version:-} -s -w "%{http_code}" -o "${tempcont}" "${2}" -I)"
345     curlret="${?}"
346   elif [[ "${1}" = "get" ]]; then
347     statuscode="$(curl ${ip_version:-} -s -w "%{http_code}" -o "${tempcont}" "${2}")"
348     curlret="${?}"
349   elif [[ "${1}" = "post" ]]; then
350     statuscode="$(curl ${ip_version:-} -s -w "%{http_code}" -o "${tempcont}" "${2}" -d "${3}")"
351     curlret="${?}"
352   else
353     set -e
354     _exiterr "Unknown request method: ${1}"
355   fi
356   set -e
357
358   if [[ ! "${curlret}" = "0" ]]; then
359     _exiterr "Problem connecting to server (${1} for ${2}; curl returned with ${curlret})"
360   fi
361
362   if [[ ! "${statuscode:0:1}" = "2" ]]; then
363     echo "  + ERROR: An error occurred while sending ${1}-request to ${2} (Status ${statuscode})" >&2
364     echo >&2
365     echo "Details:" >&2
366     cat "${tempcont}" >&2
367     echo >&2
368     echo >&2
369
370     # An exclusive hook for the {1}-request error might be useful (e.g., for sending an e-mail to admins)
371     if [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" != "yes" ]]; then
372       errtxt=`cat ${tempcont}`
373       "${HOOK}" "request_failure" "${statuscode}" "${errtxt}" "${1}"
374     fi
375
376     rm -f "${tempcont}"
377
378     # Wait for hook script to clean the challenge if used
379     if [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" != "yes" ]] && [[ -n "${challenge_token:+set}" ]]; then
380       "${HOOK}" "clean_challenge" '' "${challenge_token}" "${keyauth}"
381     fi
382
383     # remove temporary domains.txt file if used
384     [[ -n "${PARAM_DOMAIN:-}" && -n "${DOMAINS_TXT:-}" ]] && rm "${DOMAINS_TXT}"
385     exit 1
386   fi
387
388   cat "${tempcont}"
389   rm -f "${tempcont}"
390 }
391
392 # Send signed request
393 signed_request() {
394   # Encode payload as urlbase64
395   payload64="$(printf '%s' "${2}" | urlbase64)"
396
397   # Retrieve nonce from acme-server
398   nonce="$(http_request head "${CA}" | grep Replay-Nonce: | awk -F ': ' '{print $2}' | tr -d '\n\r')"
399
400   # Build header with just our public key and algorithm information
401   header='{"alg": "RS256", "jwk": {"e": "'"${pubExponent64}"'", "kty": "RSA", "n": "'"${pubMod64}"'"}}'
402
403   # Build another header which also contains the previously received nonce and encode it as urlbase64
404   protected='{"alg": "RS256", "jwk": {"e": "'"${pubExponent64}"'", "kty": "RSA", "n": "'"${pubMod64}"'"}, "nonce": "'"${nonce}"'"}'
405   protected64="$(printf '%s' "${protected}" | urlbase64)"
406
407   # Sign header with nonce and our payload with our private key and encode signature as urlbase64
408   signed64="$(printf '%s' "${protected64}.${payload64}" | openssl dgst -sha256 -sign "${ACCOUNT_KEY}" | urlbase64)"
409
410   # Send header + extended header + payload + signature to the acme-server
411   data='{"header": '"${header}"', "protected": "'"${protected64}"'", "payload": "'"${payload64}"'", "signature": "'"${signed64}"'"}'
412
413   http_request post "${1}" "${data}"
414 }
415
416 # Extracts all subject names from a CSR
417 # Outputs either the CN, or the SANs, one per line
418 extract_altnames() {
419   csr="${1}" # the CSR itself (not a file)
420
421   if ! <<<"${csr}" openssl req -verify -noout 2>/dev/null; then
422     _exiterr "Certificate signing request isn't valid"
423   fi
424
425   reqtext="$( <<<"${csr}" openssl req -noout -text )"
426   if <<<"${reqtext}" grep -q '^[[:space:]]*X509v3 Subject Alternative Name:[[:space:]]*$'; then
427     # SANs used, extract these
428     altnames="$( <<<"${reqtext}" grep -A1 '^[[:space:]]*X509v3 Subject Alternative Name:[[:space:]]*$' | tail -n1 )"
429     # split to one per line:
430     # shellcheck disable=SC1003
431     altnames="$( <<<"${altnames}" _sed -e 's/^[[:space:]]*//; s/, /\'$'\n''/g' )"
432     # we can only get DNS: ones signed
433     if grep -qv '^DNS:' <<<"${altnames}"; then
434       _exiterr "Certificate signing request contains non-DNS Subject Alternative Names"
435     fi
436     # strip away the DNS: prefix
437     altnames="$( <<<"${altnames}" _sed -e 's/^DNS://' )"
438     echo "${altnames}"
439
440   else
441     # No SANs, extract CN
442     altnames="$( <<<"${reqtext}" grep '^[[:space:]]*Subject:' | _sed -e 's/.* CN=([^ /,]*).*/\1/' )"
443     echo "${altnames}"
444   fi
445 }
446
447 # Create certificate for domain(s) and outputs it FD 3
448 sign_csr() {
449   csr="${1}" # the CSR itself (not a file)
450
451   if { true >&3; } 2>/dev/null; then
452     : # fd 3 looks OK
453   else
454     _exiterr "sign_csr: FD 3 not open"
455   fi
456
457   shift 1 || true
458   altnames="${*:-}"
459   if [ -z "${altnames}" ]; then
460     altnames="$( extract_altnames "${csr}" )"
461   fi
462
463   if [[ -z "${CA_NEW_AUTHZ}" ]] || [[ -z "${CA_NEW_CERT}" ]]; then
464     _exiterr "Certificate authority doesn't allow certificate signing"
465   fi
466
467   local idx=0
468   if [[ -n "${ZSH_VERSION:-}" ]]; then
469     local -A challenge_altnames challenge_uris challenge_tokens keyauths deploy_args
470   else
471     local -a challenge_altnames challenge_uris challenge_tokens keyauths deploy_args
472   fi
473
474   # Request challenges
475   for altname in ${altnames}; do
476     # Ask the acme-server for new challenge token and extract them from the resulting json block
477     echo " + Requesting challenge for ${altname}..."
478     response="$(signed_request "${CA_NEW_AUTHZ}" '{"resource": "new-authz", "identifier": {"type": "dns", "value": "'"${altname}"'"}}' | clean_json)"
479
480     challenge_status="$(printf '%s' "${response}" | rm_json_arrays | get_json_string_value status)"
481     if [ "${challenge_status}" = "valid" ]; then
482        echo " + Already validated!"
483        continue
484     fi
485
486     challenges="$(printf '%s\n' "${response}" | sed -n 's/.*\("challenges":[^\[]*\[[^]]*]\).*/\1/p')"
487     repl=$'\n''{' # fix syntax highlighting in Vim
488     challenge="$(printf "%s" "${challenges//\{/${repl}}" | grep \""${CHALLENGETYPE}"\")"
489     challenge_token="$(printf '%s' "${challenge}" | get_json_string_value token | _sed 's/[^A-Za-z0-9_\-]/_/g')"
490     challenge_uri="$(printf '%s' "${challenge}" | get_json_string_value uri)"
491
492     if [[ -z "${challenge_token}" ]] || [[ -z "${challenge_uri}" ]]; then
493       _exiterr "Can't retrieve challenges (${response})"
494     fi
495
496     # Challenge response consists of the challenge token and the thumbprint of our public certificate
497     keyauth="${challenge_token}.${thumbprint}"
498
499     case "${CHALLENGETYPE}" in
500       "http-01")
501         # Store challenge response in well-known location and make world-readable (so that a webserver can access it)
502         printf '%s' "${keyauth}" > "${WELLKNOWN}/${challenge_token}"
503         chmod a+r "${WELLKNOWN}/${challenge_token}"
504         keyauth_hook="${keyauth}"
505         ;;
506       "dns-01")
507         # Generate DNS entry content for dns-01 validation
508         keyauth_hook="$(printf '%s' "${keyauth}" | openssl dgst -sha256 -binary | urlbase64)"
509         ;;
510     esac
511
512     challenge_altnames[${idx}]="${altname}"
513     challenge_uris[${idx}]="${challenge_uri}"
514     keyauths[${idx}]="${keyauth}"
515     challenge_tokens[${idx}]="${challenge_token}"
516     # Note: assumes args will never have spaces!
517     deploy_args[${idx}]="${altname} ${challenge_token} ${keyauth_hook}"
518     idx=$((idx+1))
519   done
520   challenge_count="${idx}"
521
522   # Wait for hook script to deploy the challenges if used
523   if [[ ${challenge_count} -ne 0 ]]; then
524     # shellcheck disable=SC2068
525     [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" = "yes" ]] && "${HOOK}" "deploy_challenge" ${deploy_args[@]}
526   fi
527
528   # Respond to challenges
529   reqstatus="valid"
530   idx=0
531   if [ ${challenge_count} -ne 0 ]; then
532     for altname in "${challenge_altnames[@]:0}"; do
533       challenge_token="${challenge_tokens[${idx}]}"
534       keyauth="${keyauths[${idx}]}"
535
536       # Wait for hook script to deploy the challenge if used
537       # shellcheck disable=SC2086
538       [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" != "yes" ]] && "${HOOK}" "deploy_challenge" ${deploy_args[${idx}]}
539
540       # Ask the acme-server to verify our challenge and wait until it is no longer pending
541       echo " + Responding to challenge for ${altname}..."
542       result="$(signed_request "${challenge_uris[${idx}]}" '{"resource": "challenge", "keyAuthorization": "'"${keyauth}"'"}' | clean_json)"
543
544       reqstatus="$(printf '%s\n' "${result}" | get_json_string_value status)"
545
546       while [[ "${reqstatus}" = "pending" ]]; do
547         sleep 1
548         result="$(http_request get "${challenge_uris[${idx}]}")"
549         reqstatus="$(printf '%s\n' "${result}" | get_json_string_value status)"
550       done
551
552       [[ "${CHALLENGETYPE}" = "http-01" ]] && rm -f "${WELLKNOWN}/${challenge_token}"
553
554       # Wait for hook script to clean the challenge if used
555       if [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" != "yes" ]] && [[ -n "${challenge_token}" ]]; then
556         # shellcheck disable=SC2086
557         "${HOOK}" "clean_challenge" ${deploy_args[${idx}]}
558       fi
559       idx=$((idx+1))
560
561       if [[ "${reqstatus}" = "valid" ]]; then
562         echo " + Challenge is valid!"
563       else
564         [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" != "yes" ]] && "${HOOK}" "invalid_challenge" "${altname}" "${result}"
565       fi
566     done
567   fi
568
569   # Wait for hook script to clean the challenges if used
570   # shellcheck disable=SC2068
571   if [[ ${challenge_count} -ne 0 ]]; then
572     [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" = "yes" ]] && "${HOOK}" "clean_challenge" ${deploy_args[@]}
573   fi
574
575   if [[ "${reqstatus}" != "valid" ]]; then
576     # Clean up any remaining challenge_tokens if we stopped early
577     if [[ "${CHALLENGETYPE}" = "http-01" ]] && [[ ${challenge_count} -ne 0 ]]; then
578       while [ ${idx} -lt ${#challenge_tokens[@]} ]; do
579         rm -f "${WELLKNOWN}/${challenge_tokens[${idx}]}"
580         idx=$((idx+1))
581       done
582     fi
583
584     _exiterr "Challenge is invalid! (returned: ${reqstatus}) (result: ${result})"
585   fi
586
587   # Finally request certificate from the acme-server and store it in cert-${timestamp}.pem and link from cert.pem
588   echo " + Requesting certificate..."
589   csr64="$( <<<"${csr}" openssl req -outform DER | urlbase64)"
590   crt64="$(signed_request "${CA_NEW_CERT}" '{"resource": "new-cert", "csr": "'"${csr64}"'"}' | openssl base64 -e)"
591   crt="$( printf -- '-----BEGIN CERTIFICATE-----\n%s\n-----END CERTIFICATE-----\n' "${crt64}" )"
592
593   # Try to load the certificate to detect corruption
594   echo " + Checking certificate..."
595   _openssl x509 -text <<<"${crt}"
596
597   echo "${crt}" >&3
598
599   unset challenge_token
600   echo " + Done!"
601 }
602
603 # Create certificate for domain(s)
604 sign_domain() {
605   domain="${1}"
606   altnames="${*}"
607   timestamp="$(date +%s)"
608
609   echo " + Signing domains..."
610   if [[ -z "${CA_NEW_AUTHZ}" ]] || [[ -z "${CA_NEW_CERT}" ]]; then
611     _exiterr "Certificate authority doesn't allow certificate signing"
612   fi
613
614   # If there is no existing certificate directory => make it
615   if [[ ! -e "${CERTDIR}/${domain}" ]]; then
616     echo " + Creating new directory ${CERTDIR}/${domain} ..."
617     mkdir -p "${CERTDIR}/${domain}" || _exiterr "Unable to create directory ${CERTDIR}/${domain}"
618   fi
619
620   privkey="privkey.pem"
621   # generate a new private key if we need or want one
622   if [[ ! -r "${CERTDIR}/${domain}/privkey.pem" ]] || [[ "${PRIVATE_KEY_RENEW}" = "yes" ]]; then
623     echo " + Generating private key..."
624     privkey="privkey-${timestamp}.pem"
625     case "${KEY_ALGO}" in
626       rsa) _openssl genrsa -out "${CERTDIR}/${domain}/privkey-${timestamp}.pem" "${KEYSIZE}";;
627       prime256v1|secp384r1) _openssl ecparam -genkey -name "${KEY_ALGO}" -out "${CERTDIR}/${domain}/privkey-${timestamp}.pem";;
628     esac
629   fi
630   # move rolloverkey into position (if any)
631   if [[ -r "${CERTDIR}/${domain}/privkey.pem" && -r "${CERTDIR}/${domain}/privkey.roll.pem" && "${PRIVATE_KEY_RENEW}" = "yes" && "${PRIVATE_KEY_ROLLOVER}" = "yes" ]]; then
632     echo " + Moving Rolloverkey into position....  "
633     mv "${CERTDIR}/${domain}/privkey.roll.pem" "${CERTDIR}/${domain}/privkey-tmp.pem"
634     mv "${CERTDIR}/${domain}/privkey-${timestamp}.pem" "${CERTDIR}/${domain}/privkey.roll.pem"
635     mv "${CERTDIR}/${domain}/privkey-tmp.pem" "${CERTDIR}/${domain}/privkey-${timestamp}.pem"
636   fi
637   # generate a new private rollover key if we need or want one
638   if [[ ! -r "${CERTDIR}/${domain}/privkey.roll.pem" && "${PRIVATE_KEY_ROLLOVER}" = "yes" && "${PRIVATE_KEY_RENEW}" = "yes" ]]; then
639     echo " + Generating private rollover key..."
640     case "${KEY_ALGO}" in
641       rsa) _openssl genrsa -out "${CERTDIR}/${domain}/privkey.roll.pem" "${KEYSIZE}";;
642       prime256v1|secp384r1) _openssl ecparam -genkey -name "${KEY_ALGO}" -out "${CERTDIR}/${domain}/privkey.roll.pem";;
643     esac
644   fi
645   # delete rolloverkeys if disabled
646   if [[ -r "${CERTDIR}/${domain}/privkey.roll.pem" && ! "${PRIVATE_KEY_ROLLOVER}" = "yes" ]]; then
647     echo " + Removing Rolloverkey (feature disabled)..."
648     rm -f "${CERTDIR}/${domain}/privkey.roll.pem"
649   fi
650
651   # Generate signing request config and the actual signing request
652   echo " + Generating signing request..."
653   SAN=""
654   for altname in ${altnames}; do
655     SAN+="DNS:${altname}, "
656   done
657   SAN="${SAN%%, }"
658   local tmp_openssl_cnf
659   tmp_openssl_cnf="$(_mktemp)"
660   cat "${OPENSSL_CNF}" > "${tmp_openssl_cnf}"
661   printf "[SAN]\nsubjectAltName=%s" "${SAN}" >> "${tmp_openssl_cnf}"
662   if [ "${OCSP_MUST_STAPLE}" = "yes" ]; then
663     printf "\n1.3.6.1.5.5.7.1.24=DER:30:03:02:01:05" >> "${tmp_openssl_cnf}"
664   fi
665   openssl req -new -sha256 -key "${CERTDIR}/${domain}/${privkey}" -out "${CERTDIR}/${domain}/cert-${timestamp}.csr" -subj "/CN=${domain}/" -reqexts SAN -config "${tmp_openssl_cnf}"
666   rm -f "${tmp_openssl_cnf}"
667
668   crt_path="${CERTDIR}/${domain}/cert-${timestamp}.pem"
669   # shellcheck disable=SC2086
670   sign_csr "$(< "${CERTDIR}/${domain}/cert-${timestamp}.csr" )" ${altnames} 3>"${crt_path}"
671
672   # Create fullchain.pem
673   echo " + Creating fullchain.pem..."
674   cat "${crt_path}" > "${CERTDIR}/${domain}/fullchain-${timestamp}.pem"
675   tmpchain="$(_mktemp)"
676   http_request get "$(openssl x509 -in "${CERTDIR}/${domain}/cert-${timestamp}.pem" -noout -text | grep 'CA Issuers - URI:' | cut -d':' -f2-)" > "${tmpchain}"
677   if grep -q "BEGIN CERTIFICATE" "${tmpchain}"; then
678     mv "${tmpchain}" "${CERTDIR}/${domain}/chain-${timestamp}.pem"
679   else
680     openssl x509 -in "${tmpchain}" -inform DER -out "${CERTDIR}/${domain}/chain-${timestamp}.pem" -outform PEM
681     rm "${tmpchain}"
682   fi
683   cat "${CERTDIR}/${domain}/chain-${timestamp}.pem" >> "${CERTDIR}/${domain}/fullchain-${timestamp}.pem"
684
685   # Update symlinks
686   [[ "${privkey}" = "privkey.pem" ]] || ln -sf "privkey-${timestamp}.pem" "${CERTDIR}/${domain}/privkey.pem"
687
688   ln -sf "chain-${timestamp}.pem" "${CERTDIR}/${domain}/chain.pem"
689   ln -sf "fullchain-${timestamp}.pem" "${CERTDIR}/${domain}/fullchain.pem"
690   ln -sf "cert-${timestamp}.csr" "${CERTDIR}/${domain}/cert.csr"
691   ln -sf "cert-${timestamp}.pem" "${CERTDIR}/${domain}/cert.pem"
692
693   # Wait for hook script to clean the challenge and to deploy cert if used
694   export KEY_ALGO
695   [[ -n "${HOOK}" ]] && "${HOOK}" "deploy_cert" "${domain}" "${CERTDIR}/${domain}/privkey.pem" "${CERTDIR}/${domain}/cert.pem" "${CERTDIR}/${domain}/fullchain.pem" "${CERTDIR}/${domain}/chain.pem" "${timestamp}"
696
697   unset challenge_token
698   echo " + Done!"
699 }
700
701 # Usage: --cron (-c)
702 # Description: Sign/renew non-existant/changed/expiring certificates.
703 command_sign_domains() {
704   init_system
705
706   if [[ -n "${PARAM_DOMAIN:-}" ]]; then
707     DOMAINS_TXT="$(_mktemp)"
708     printf -- "${PARAM_DOMAIN}" > "${DOMAINS_TXT}"
709   elif [[ -e "${DOMAINS_TXT}" ]]; then
710     if [[ ! -r "${DOMAINS_TXT}" ]]; then
711       _exiterr "domains.txt found but not readable"
712     fi
713   else
714     _exiterr "domains.txt not found and --domain not given"
715   fi
716
717   # Generate certificates for all domains found in domains.txt. Check if existing certificate are about to expire
718   ORIGIFS="${IFS}"
719   IFS=$'\n'
720   for line in $(<"${DOMAINS_TXT}" tr -d '\r' | awk '{print tolower($0)}' | _sed -e 's/^[[:space:]]*//g' -e 's/[[:space:]]*$//g' -e 's/[[:space:]]+/ /g' | (grep -vE '^(#|$)' || true)); do
721     reset_configvars
722     IFS="${ORIGIFS}"
723     domain="$(printf '%s\n' "${line}" | cut -d' ' -f1)"
724     morenames="$(printf '%s\n' "${line}" | cut -s -d' ' -f2-)"
725     cert="${CERTDIR}/${domain}/cert.pem"
726
727     force_renew="${PARAM_FORCE:-no}"
728
729     if [[ -z "${morenames}" ]];then
730       echo "Processing ${domain}"
731     else
732       echo "Processing ${domain} with alternative names: ${morenames}"
733     fi
734
735     # read cert config
736     # for now this loads the certificate specific config in a subshell and parses a diff of set variables.
737     # we could just source the config file but i decided to go this way to protect people from accidentally overriding
738     # variables used internally by this script itself.
739     if [[ -n "${DOMAINS_D}" ]]; then
740       certconfig="${DOMAINS_D}/${domain}"
741     else
742       certconfig="${CERTDIR}/${domain}/config"
743     fi
744
745     if [ -f "${certconfig}" ]; then
746       echo " + Using certificate specific config file!"
747       ORIGIFS="${IFS}"
748       IFS=$'\n'
749       for cfgline in $(
750         beforevars="$(_mktemp)"
751         aftervars="$(_mktemp)"
752         set > "${beforevars}"
753         # shellcheck disable=SC1090
754         . "${certconfig}"
755         set > "${aftervars}"
756         diff -u "${beforevars}" "${aftervars}" | grep -E '^\+[^+]'
757         rm "${beforevars}"
758         rm "${aftervars}"
759       ); do
760         config_var="$(echo "${cfgline:1}" | cut -d'=' -f1)"
761         config_value="$(echo "${cfgline:1}" | cut -d'=' -f2-)"
762         case "${config_var}" in
763           KEY_ALGO|OCSP_MUST_STAPLE|PRIVATE_KEY_RENEW|PRIVATE_KEY_ROLLOVER|KEYSIZE|CHALLENGETYPE|HOOK|WELLKNOWN|HOOK_CHAIN|OPENSSL_CNF|RENEW_DAYS)
764             echo "   + ${config_var} = ${config_value}"
765             declare -- "${config_var}=${config_value}"
766             ;;
767           _) ;;
768           *) echo "   ! Setting ${config_var} on a per-certificate base is not (yet) supported"
769         esac
770       done
771       IFS="${ORIGIFS}"
772     fi
773     verify_config
774
775     if [[ -e "${cert}" ]]; then
776       printf " + Checking domain name(s) of existing cert..."
777
778       certnames="$(openssl x509 -in "${cert}" -text -noout | grep DNS: | _sed 's/DNS://g' | tr -d ' ' | tr ',' '\n' | sort -u | tr '\n' ' ' | _sed 's/ $//')"
779       givennames="$(echo "${domain}" "${morenames}"| tr ' ' '\n' | sort -u | tr '\n' ' ' | _sed 's/ $//' | _sed 's/^ //')"
780
781       if [[ "${certnames}" = "${givennames}" ]]; then
782         echo " unchanged."
783       else
784         echo " changed!"
785         echo " + Domain name(s) are not matching!"
786         echo " + Names in old certificate: ${certnames}"
787         echo " + Configured names: ${givennames}"
788         echo " + Forcing renew."
789         force_renew="yes"
790       fi
791     fi
792
793     if [[ -e "${cert}" ]]; then
794       echo " + Checking expire date of existing cert..."
795       valid="$(openssl x509 -enddate -noout -in "${cert}" | cut -d= -f2- )"
796
797       printf " + Valid till %s " "${valid}"
798       if openssl x509 -checkend $((RENEW_DAYS * 86400)) -noout -in "${cert}"; then
799         printf "(Longer than %d days). " "${RENEW_DAYS}"
800         if [[ "${force_renew}" = "yes" ]]; then
801           echo "Ignoring because renew was forced!"
802         else
803           # Certificate-Names unchanged and cert is still valid
804           echo "Skipping renew!"
805           [[ -n "${HOOK}" ]] && "${HOOK}" "unchanged_cert" "${domain}" "${CERTDIR}/${domain}/privkey.pem" "${CERTDIR}/${domain}/cert.pem" "${CERTDIR}/${domain}/fullchain.pem" "${CERTDIR}/${domain}/chain.pem"
806           continue
807         fi
808       else
809         echo "(Less than ${RENEW_DAYS} days). Renewing!"
810       fi
811     fi
812
813     # shellcheck disable=SC2086
814     if [[ "${PARAM_KEEP_GOING:-}" = "yes" ]]; then
815       sign_domain ${line} &
816       wait $! || true
817     else
818       sign_domain ${line}
819     fi
820   done
821
822   # remove temporary domains.txt file if used
823   [[ -n "${PARAM_DOMAIN:-}" ]] && rm -f "${DOMAINS_TXT}"
824
825   [[ -n "${HOOK}" ]] && "${HOOK}" "exit_hook"
826   exit 0
827 }
828
829 # Usage: --signcsr (-s) path/to/csr.pem
830 # Description: Sign a given CSR, output CRT on stdout (advanced usage)
831 command_sign_csr() {
832   # redirect stdout to stderr
833   # leave stdout over at fd 3 to output the cert
834   exec 3>&1 1>&2
835
836   init_system
837
838   csrfile="${1}"
839   if [ ! -r "${csrfile}" ]; then
840     _exiterr "Could not read certificate signing request ${csrfile}"
841   fi
842
843   # gen cert
844   certfile="$(_mktemp)"
845   sign_csr "$(< "${csrfile}" )" 3> "${certfile}"
846
847   # print cert
848   echo "# CERT #" >&3
849   cat "${certfile}" >&3
850   echo >&3
851
852   # print chain
853   if [ -n "${PARAM_FULL_CHAIN:-}" ]; then
854     # get and convert ca cert
855     chainfile="$(_mktemp)"
856     tmpchain="$(_mktemp)"
857     http_request get "$(openssl x509 -in "${certfile}" -noout -text | grep 'CA Issuers - URI:' | cut -d':' -f2-)" > "${tmpchain}"
858     if grep -q "BEGIN CERTIFICATE" "${tmpchain}"; then
859       mv "${tmpchain}" "${chainfile}"
860     else
861       openssl x509 -in "${tmpchain}" -inform DER -out "${chainfile}" -outform PEM
862       rm "${tmpchain}"
863     fi
864
865     echo "# CHAIN #" >&3
866     cat "${chainfile}" >&3
867
868     rm "${chainfile}"
869   fi
870
871   # cleanup
872   rm "${certfile}"
873
874   exit 0
875 }
876
877 # Usage: --revoke (-r) path/to/cert.pem
878 # Description: Revoke specified certificate
879 command_revoke() {
880   init_system
881
882   [[ -n "${CA_REVOKE_CERT}" ]] || _exiterr "Certificate authority doesn't allow certificate revocation."
883
884   cert="${1}"
885   if [[ -L "${cert}" ]]; then
886     # follow symlink and use real certificate name (so we move the real file and not the symlink at the end)
887     local link_target
888     link_target="$(readlink -n "${cert}")"
889     if [[ "${link_target}" =~ ^/ ]]; then
890       cert="${link_target}"
891     else
892       cert="$(dirname "${cert}")/${link_target}"
893     fi
894   fi
895   [[ -f "${cert}" ]] || _exiterr "Could not find certificate ${cert}"
896
897   echo "Revoking ${cert}"
898
899   cert64="$(openssl x509 -in "${cert}" -inform PEM -outform DER | urlbase64)"
900   response="$(signed_request "${CA_REVOKE_CERT}" '{"resource": "revoke-cert", "certificate": "'"${cert64}"'"}' | clean_json)"
901   # if there is a problem with our revoke request _request (via signed_request) will report this and "exit 1" out
902   # so if we are here, it is safe to assume the request was successful
903   echo " + Done."
904   echo " + Renaming certificate to ${cert}-revoked"
905   mv -f "${cert}" "${cert}-revoked"
906 }
907
908 # Usage: --cleanup (-gc)
909 # Description: Move unused certificate files to archive directory
910 command_cleanup() {
911   load_config
912
913   # Create global archive directory if not existant
914   if [[ ! -e "${BASEDIR}/archive" ]]; then
915     mkdir "${BASEDIR}/archive"
916   fi
917
918   # Loop over all certificate directories
919   for certdir in "${CERTDIR}/"*; do
920     # Skip if entry is not a folder
921     [[ -d "${certdir}" ]] || continue
922
923     # Get certificate name
924     certname="$(basename "${certdir}")"
925
926     # Create certitifaces archive directory if not existant
927     archivedir="${BASEDIR}/archive/${certname}"
928     if [[ ! -e "${archivedir}" ]]; then
929       mkdir "${archivedir}"
930     fi
931
932     # Loop over file-types (certificates, keys, signing-requests, ...)
933     for filetype in cert.csr cert.pem chain.pem fullchain.pem privkey.pem; do
934       # Skip if symlink is broken
935       [[ -r "${certdir}/${filetype}" ]] || continue
936
937       # Look up current file in use
938       current="$(basename "$(readlink "${certdir}/${filetype}")")"
939
940       # Split filetype into name and extension
941       filebase="$(echo "${filetype}" | cut -d. -f1)"
942       fileext="$(echo "${filetype}" | cut -d. -f2)"
943
944       # Loop over all files of this type
945       for file in "${certdir}/${filebase}-"*".${fileext}"; do
946         # Handle case where no files match the wildcard
947         [[ -f "${file}" ]] || break
948
949         # Check if current file is in use, if unused move to archive directory
950         filename="$(basename "${file}")"
951         if [[ ! "${filename}" = "${current}" ]]; then
952           echo "Moving unused file to archive directory: ${certname}/${filename}"
953           mv "${certdir}/${filename}" "${archivedir}/${filename}"
954         fi
955       done
956     done
957   done
958
959   exit 0
960 }
961
962 # Usage: --help (-h)
963 # Description: Show help text
964 command_help() {
965   printf "Usage: %s [-h] [command [argument]] [parameter [argument]] [parameter [argument]] ...\n\n" "${0}"
966   printf "Default command: help\n\n"
967   echo "Commands:"
968   grep -e '^[[:space:]]*# Usage:' -e '^[[:space:]]*# Description:' -e '^command_.*()[[:space:]]*{' "${0}" | while read -r usage; read -r description; read -r command; do
969     if [[ ! "${usage}" =~ Usage ]] || [[ ! "${description}" =~ Description ]] || [[ ! "${command}" =~ ^command_ ]]; then
970       _exiterr "Error generating help text."
971     fi
972     printf " %-32s %s\n" "${usage##"# Usage: "}" "${description##"# Description: "}"
973   done
974   printf -- "\nParameters:\n"
975   grep -E -e '^[[:space:]]*# PARAM_Usage:' -e '^[[:space:]]*# PARAM_Description:' "${0}" | while read -r usage; read -r description; do
976     if [[ ! "${usage}" =~ Usage ]] || [[ ! "${description}" =~ Description ]]; then
977       _exiterr "Error generating help text."
978     fi
979     printf " %-32s %s\n" "${usage##"# PARAM_Usage: "}" "${description##"# PARAM_Description: "}"
980   done
981 }
982
983 # Usage: --env (-e)
984 # Description: Output configuration variables for use in other scripts
985 command_env() {
986   echo "# dehydrated configuration"
987   load_config
988   typeset -p CA LICENSE CERTDIR CHALLENGETYPE DOMAINS_D DOMAINS_TXT HOOK HOOK_CHAIN RENEW_DAYS ACCOUNT_KEY ACCOUNT_KEY_JSON KEYSIZE WELLKNOWN PRIVATE_KEY_RENEW OPENSSL_CNF CONTACT_EMAIL LOCKFILE
989 }
990
991 # Main method (parses script arguments and calls command_* methods)
992 main() {
993   COMMAND=""
994   set_command() {
995     [[ -z "${COMMAND}" ]] || _exiterr "Only one command can be executed at a time. See help (-h) for more information."
996     COMMAND="${1}"
997   }
998
999   check_parameters() {
1000     if [[ -z "${1:-}" ]]; then
1001       echo "The specified command requires additional parameters. See help:" >&2
1002       echo >&2
1003       command_help >&2
1004       exit 1
1005     elif [[ "${1:0:1}" = "-" ]]; then
1006       _exiterr "Invalid argument: ${1}"
1007     fi
1008   }
1009
1010   [[ -z "${@}" ]] && eval set -- "--help"
1011
1012   while (( ${#} )); do
1013     case "${1}" in
1014       --help|-h)
1015         command_help
1016         exit 0
1017         ;;
1018
1019       --env|-e)
1020         set_command env
1021         ;;
1022
1023       --cron|-c)
1024         set_command sign_domains
1025         ;;
1026
1027       --signcsr|-s)
1028         shift 1
1029         set_command sign_csr
1030         check_parameters "${1:-}"
1031         PARAM_CSR="${1}"
1032         ;;
1033
1034       --revoke|-r)
1035         shift 1
1036         set_command revoke
1037         check_parameters "${1:-}"
1038         PARAM_REVOKECERT="${1}"
1039         ;;
1040
1041       --cleanup|-gc)
1042         set_command cleanup
1043         ;;
1044
1045       # PARAM_Usage: --full-chain (-fc)
1046       # PARAM_Description: Print full chain when using --signcsr
1047       --full-chain|-fc)
1048         PARAM_FULL_CHAIN="1"
1049         ;;
1050
1051       # PARAM_Usage: --ipv4 (-4)
1052       # PARAM_Description: Resolve names to IPv4 addresses only
1053       --ipv4|-4)
1054         PARAM_IP_VERSION="4"
1055         ;;
1056
1057       # PARAM_Usage: --ipv6 (-6)
1058       # PARAM_Description: Resolve names to IPv6 addresses only
1059       --ipv6|-6)
1060         PARAM_IP_VERSION="6"
1061         ;;
1062
1063       # PARAM_Usage: --domain (-d) domain.tld
1064       # PARAM_Description: Use specified domain name(s) instead of domains.txt entry (one certificate!)
1065       --domain|-d)
1066         shift 1
1067         check_parameters "${1:-}"
1068         if [[ -z "${PARAM_DOMAIN:-}" ]]; then
1069           PARAM_DOMAIN="${1}"
1070         else
1071           PARAM_DOMAIN="${PARAM_DOMAIN} ${1}"
1072          fi
1073         ;;
1074
1075       # PARAM_Usage: --keep-going (-g)
1076       # PARAM_Description: Keep going after encountering an error while creating/renewing multiple certificates in cron mode
1077       --keep-going|-g)
1078         PARAM_KEEP_GOING="yes"
1079         ;;
1080
1081       # PARAM_Usage: --force (-x)
1082       # PARAM_Description: Force renew of certificate even if it is longer valid than value in RENEW_DAYS
1083       --force|-x)
1084         PARAM_FORCE="yes"
1085         ;;
1086
1087       # PARAM_Usage: --no-lock (-n)
1088       # PARAM_Description: Don't use lockfile (potentially dangerous!)
1089       --no-lock|-n)
1090         PARAM_NO_LOCK="yes"
1091         ;;
1092
1093       # PARAM_Usage: --lock-suffix example.com
1094       # PARAM_Description: Suffix lockfile name with a string (useful for with -d)
1095       --lock-suffix)
1096         shift 1
1097         check_parameters "${1:-}"
1098         PARAM_LOCKFILE_SUFFIX="${1}"
1099         ;;
1100
1101       # PARAM_Usage: --ocsp
1102       # PARAM_Description: Sets option in CSR indicating OCSP stapling to be mandatory
1103       --ocsp)
1104         PARAM_OCSP_MUST_STAPLE="yes"
1105         ;;
1106
1107       # PARAM_Usage: --privkey (-p) path/to/key.pem
1108       # PARAM_Description: Use specified private key instead of account key (useful for revocation)
1109       --privkey|-p)
1110         shift 1
1111         check_parameters "${1:-}"
1112         PARAM_ACCOUNT_KEY="${1}"
1113         ;;
1114
1115       # PARAM_Usage: --config (-f) path/to/config
1116       # PARAM_Description: Use specified config file
1117       --config|-f)
1118         shift 1
1119         check_parameters "${1:-}"
1120         CONFIG="${1}"
1121         ;;
1122
1123       # PARAM_Usage: --hook (-k) path/to/hook.sh
1124       # PARAM_Description: Use specified script for hooks
1125       --hook|-k)
1126         shift 1
1127         check_parameters "${1:-}"
1128         PARAM_HOOK="${1}"
1129         ;;
1130
1131       # PARAM_Usage: --out (-o) certs/directory
1132       # PARAM_Description: Output certificates into the specified directory
1133       --out|-o)
1134         shift 1
1135         check_parameters "${1:-}"
1136         PARAM_CERTDIR="${1}"
1137         ;;
1138
1139       # PARAM_Usage: --challenge (-t) http-01|dns-01
1140       # PARAM_Description: Which challenge should be used? Currently http-01 and dns-01 are supported
1141       --challenge|-t)
1142         shift 1
1143         check_parameters "${1:-}"
1144         PARAM_CHALLENGETYPE="${1}"
1145         ;;
1146
1147       # PARAM_Usage: --algo (-a) rsa|prime256v1|secp384r1
1148       # PARAM_Description: Which public key algorithm should be used? Supported: rsa, prime256v1 and secp384r1
1149       --algo|-a)
1150         shift 1
1151         check_parameters "${1:-}"
1152         PARAM_KEY_ALGO="${1}"
1153         ;;
1154
1155       *)
1156         echo "Unknown parameter detected: ${1}" >&2
1157         echo >&2
1158         command_help >&2
1159         exit 1
1160         ;;
1161     esac
1162
1163     shift 1
1164   done
1165
1166   case "${COMMAND}" in
1167     env) command_env;;
1168     sign_domains) command_sign_domains;;
1169     sign_csr) command_sign_csr "${PARAM_CSR}";;
1170     revoke) command_revoke "${PARAM_REVOKECERT}";;
1171     cleanup) command_cleanup;;
1172     *) command_help; exit 1;;
1173   esac
1174 }
1175
1176 # Determine OS type
1177 OSTYPE="$(uname)"
1178
1179 # Check for missing dependencies
1180 check_dependencies
1181
1182 # Run script
1183 main "${@:-}"